#include <minigui.ch>
#include <dbstruct.ch>

Function Main

public dbo := nil
private lopened := .f.

set navigation extended
set date ital
set century on

define window sql at 0,0 width 600 height 600 main title "DBF2MySQL" on release iif(dbo <> nil, dbo:destroy(),) icon "icon1" nosize nomaximize
   define frame mysqlframe
      row 10
      col 5
      width 270
      height 210
      caption "Source && MySQL Connection Details"
   end frame
   define label hostlabel
      row 30
      col 10
      width 100
      value "Host"
   end label
   define textbox host
      row 30
      col 110
      width 150
      value "localhost"
   end textbox
   define label userlabel
      row 60
      col 10
      width 100
      value "User"
   end label
   define textbox user
      row 60
      col 110
      width 150
      value ""
   end textbox
   define label passlabel
      row 90
      col 10
      width 100
      value "Password"
   end label
   define textbox pass
      row 90
      col 110
      width 150
      password .t.
   end textbox
   define button connect
      row 120
      col 10
      width 50
      caption "Connect"
      action connectdb()
   end button
   define label connection
      row 130
      col 70
      width 190
      value "No Connection"
      fontbold .t.
      fontcolor {255,0,0}
   end label
   define label dblabel
      row 160
      col 10
      width 100
      value "Database Name"
   end label
   define combobox databases
      row 160
      col 110
      width 150
      onchange databasechanged()
   end combobox
   define label selectdbflabel
      row 190
      col 10
      width 100
      value "Select dbf"
   end label
   define textbox dbfname
      row 190
      col 110
      width 100
   end textbox
   define button browsedbf
      row 190
      col 220
      width 50
      caption "Open"
      action browsefordbf()
   end button
   define button browsedbfs
      row 190
      col 320
      width 150
      caption "Export Multiple"
      action browsefordbfs()
   end button
   define frame destframe
      row 10
      col 280
      width 290
      height 210
      caption "Destination Details"
   end frame
   define radiogroup destchoice
      row 30
      col 285
      width 100
      onchange destinationchanged()
      options {"Existing Table","New Table"}
   end radiogroup
   define combobox tables
      row 30
      col 395
      width 160
      on change sqltablechanged()
   end combobox
   define textbox newtable
      row 60
      col 395
      width 160
   end textbox
   define checkbox deleteprevious
      row 90
      col 285
      caption "Delete Previous Data before export"
      width 250
   end checkbox
   define label status
      row 160
      col 285
      width 300
      value ""
   end label
   define progressbar progress
      row 190
      col 285
      width 200
   end progressbar
   define button export
      row 190
      col 510
      width 50
      caption "Export"
      fontbold .t.
      action export2sql()
   end button
   
   
   define frame existing
      row 220
      col 5
      width 565
      height 315
      caption "Existing table details and column selection"
   end frame   
   define label dbffieldslabel
      row 250
      col 10
      width 150
      value "DBF Table Fields"
   end label
   define grid dbfieldlist
      row 270
      col 10
      width 260
      widths {160,80}
      headers {"Field Name","Type"}
      justify {0,0}
      height 120
   end grid
   define label sqlfieldslabel
      row 250
      col 280
      width 150
      value "MySQL Table Fields"
   end label
   define grid sqlfieldlist
      row 270
      col 280
      height 120
      width 260
      widths {160,80}
      headers {"Field Name","Type"}
      justify {0,0}
   end grid
   define button add
      row 270
      col 545
      width 20
      caption "+"
      fontbold .t.
      action addfield()
   end button
   define label matchedlabel
      row 390
      col 240
      width 150
      value "Matched Fields"
   end label
   define grid matched
      row 410
      col 120
      width 330
      headers {"DBF Field","SQL Field"}
      widths {150,150}
      height 120
   end grid
   define button del
      row 410
      col 460
      width 20
      caption "-"
      fontbold .t.
      action delfield()
   end button
   define image logo1
      row 420
      col 10
      width 100
      height 100
      picture "logo"
   end image
   define label projectby
      row 540
      col 10
      value "DBF2MySQL - Utitlity created using HMG by"
      fontname "Arial"
      fontcolor {0,0,255}
      fontbold .t.
      autosize .t.
   end label
   define hyperlink email1
      row 540
      col 255
      width 120
      fontname "Arial"
      value "Sudip Bhatttacharyya"
      address "sudipb001@gmail.com"
      handcursor .t.
   end hyperlink
   define label ambersand
      row 540
      col 380
      width 10
      value "&&"
      fontbold .t.
      fontcolor {0,0,255}
      fontname "Arial"
   end label
   define hyperlink email2
      row 540
      col 400
      width 100
      fontname "Arial"
      value "S. Rathinagiri"
      address "srgiri@dataone.in"
      handcursor .t.
   end hyperlink
   
end window
sql.progress.visible := .f.
sql.destchoice.value := 2
destinationchanged()
sql.center
sql.activate
Return nil

function connectdb
local databases := {}
local i := 0
sql.tables.deleteallitems()
sql.databases.deleteallitems()
if dbo <> nil
   dbo:destroy()
endif
if connect2db(alltrim(sql.host.value),alltrim(sql.user.value),alltrim(sql.pass.value))
   sql.connection.value := "Successful!"
   sql.connection.fontcolor := {0,255,0}
   databases := sql(dbo,"show databases")   
   for i := 1 to len(databases)
      sql.databases.additem(alltrim(databases[i,1]))
   next i
   if sql.databases.itemcount > 0
      sql.databases.value := 1
   endif
else
   sql.connection.value := "No Connection"
   sql.connection.fontcolor := {255,0,0}
endif
databasechanged()
sqltablechanged()
return nil


function databasechanged()
local tables := {}
local i := 0
sql.tables.deleteallitems()
if sql.databases.value > 0
   dbo:selectdb(alltrim(sql.databases.item(sql.databases.value)))
   IF dbo:NetErr()
      msginfo(dbo:ERROR())
      RETURN .f.
   ENDIF
   tables := sql(dbo,"show tables")
   for i := 1 to len(tables)
      sql.tables.additem(alltrim(tables[i,1]))
   next i
   if sql.tables.itemcount > 0
      sql.tables.value := 1
      sqltablechanged()
   endif
endif    
return nil



function browsefordbf
local fname := sql.dbfname.value
local structarr := {}
local i := 0
sql.dbfieldlist.deleteallitems()
fname := alltrim(GetFile({{"DBF Files","*.dbf"}},"Select a dbf file",,.f.,.f.))
sql.dbfname.value := alltrim(fname)
if len(alltrim(fname)) > 0
   if file(fname)
      use &fname
      lopened := .t.
   endif
endif
if lopened
   structarr := dbstruct()
   for i := 1 to len(structarr)
      sql.dbfieldlist.additem({structarr[i,1],structarr[i,2]})
   next i
   if sql.dbfieldlist.itemcount > 0
      sql.dbfieldlist.value := 1
   endif
endif 
return nil      
   
function sqltablechanged
local adata := {}
sql.sqlfieldlist.deleteallitems()
sql.matched.deleteallitems()
if sql.tables.value > 0
   adata := sql(dbo,"show columns from "+alltrim(sql.tables.item(sql.tables.value)))
   for i := 1 to len(adata)
      sql.sqlfieldlist.additem({alltrim(adata[i,1]),alltrim(adata[i,2])})
   next i
   if sql.sqlfieldlist.itemcount > 0
      sql.sqlfieldlist.value := 1
   endif
endif
return nil

function addfield
local dbfield := ""
local sqlfield := ""
local i := 0
local linedata := {}
if sql.dbfieldlist.value == 0 .or. sql.sqlfieldlist.value == 0
   msgstop("You have to select corresponding field from both the tables")
   return nil
endif
linedata := sql.dbfieldlist.item(sql.dbfieldlist.value)
dbfield := linedata[1]
linedata := sql.sqlfieldlist.item(sql.sqlfieldlist.value)
sqlfield := linedata[1]
for i := 1 to sql.matched.itemcount
   linedata := sql.matched.item(i)
   if upper(alltrim(linedata[1])) == upper(alltrim(dbfield))
      msgstop(dbfield+" is already selected in dbf fieldlist! One field can be selected only once!")
      return nil
   endif
   if upper(alltrim(linedata[2])) == upper(alltrim(sqlfield))
      msgstop(sqlfield+" is already selected in sql fieldlist! One field can be selected only once!")
      return nil
   endif
next i
sql.matched.additem({dbfield,sqlfield})
if sql.dbfieldlist.value <> sql.dbfieldlist.itemcount
   sql.dbfieldlist.value := sql.dbfieldlist.value + 1
endif
if sql.sqlfieldlist.value <> sql.sqlfieldlist.itemcount
   sql.sqlfieldlist.value := sql.sqlfieldlist.value + 1
endif

sql.matched.value := sql.matched.itemcount
return nil

function delfield
local lineno := sql.matched.value
if lineno > 0
   sql.matched.deleteitem(lineno)
   if lineno > 1
      sql.matched.value := lineno - 1
   else
      if sql.matched.itemcount > 0
         sql.matched.value := 1
      endif
   endif
endif
return nil
      


function export2sql
if sql.destchoice.value == 1
   existingtable()
endif
if sql.destchoice.value == 2
   newtable()
endif
return nil




function existingtable
local insertstr := ""
local qstr := ""
local i := 0
local linedata := {}
local aselfields := {}
if dbo == nil
   msgstop("No Connection to server!")
   return nil
endif
if sql.matched.itemcount == 0
   msgstop("No matched fields found.")
   return nil
endif
if sql.tables.value == 0
   msgstop("You have to select the destination table!")
   return nil
endif
if sql.deleteprevious.value
   if .not. miscsql(dbo,"delete from "+alltrim(sql.tables.item(sql.tables.value)))
      return nil
   endif
endif    
insertstr := "("
for i := 1 to sql.matched.itemcount
   linedata := sql.matched.item(i)
   aadd(aselfields,alltrim(linedata[1]))
   insertstr := insertstr+alltrim(linedata[2])
   if i <> sql.matched.itemcount
      insertstr := insertstr + ","
   endif
next i
insertstr := insertstr + ")"

sql.progress.value := 0
sql.progress.visible := .t.

go top
do while .not. eof()
   qstr := "("
   for i := 1 to len(aselfields)
      curfield := aselfields[i]
      qstr := qstr + c2sql(&curfield)
      if i <> len(aselfields)
         qstr := qstr + ","
      endif
   next i
   qstr := qstr+")"
   
   //msginfo("insert into "+alltrim(sql.tables.item(sql.tables.value))+" "+insertstr+" values "+qstr)
   if miscsql(dbo,"insert into "+alltrim(sql.tables.item(sql.tables.value))+" "+insertstr+" values "+qstr)
      skip
   else
      msgstop("Error!")
      return nil
   endif
   sql.progress.value := recno()/reccount()*100

enddo

sql.progress.visible := .f.
msginfo("Successfully exported")
return nil

function destinationchanged
if sql.destchoice.value == 1
   sql.newtable.enabled := .f.
   sql.tables.enabled := .t.
   sql.dbfieldlist.enabled := .t.
   sql.sqlfieldlist.enabled := .t.
   sql.matched.enabled := .t.
   sql.add.enabled := .t.
   sql.del.enabled := .t.
   sql.deleteprevious.enabled := .t.
endif
if sql.destchoice.value == 2
   sql.newtable.enabled := .t.
   sql.tables.enabled := .f.
   sql.dbfieldlist.enabled := .f.
   sql.sqlfieldlist.enabled := .f.
   sql.matched.enabled := .f.
   sql.add.enabled := .f.
   sql.del.enabled := .f.
   sql.deleteprevious.enabled := .f.
endif
return nil



Function NewTable()
   local aStruct := {}, cSql, i, mFldNm, mFldtype, mFldLen, mFldDec, mSql,nvalues,count1
   
   if dbo == nil
      msgstop("No Connection to server!")
      return nil
   endif
      
   
   do while .not. lopened
      if msgyesno("You had not selected a DBF table. Do you want to do now?")
         browsefordbf()
      else
         return nil
      endif
   enddo

   cTable := alltrim(sql.newtable.value)
   if len(alltrim(cTable)) == 0
      msgstop("You have to enter the name of the new table!","DBF2MySQL")
      sql.newtable.setfocus()
   endif
   
   for i := 1 to sql.tables.itemcount
      if upper(alltrim(sql.tables.item(i))) == upper(alltrim(cTable))
         msgstop("Destination table already exists. Either you can give a new name or select an existing table from the list","DBF2MySQL")
         sql.newtable.setfocus()
         return nil
      endif
   next i

   aStruct = DbStruct()

   mSql := "CREATE TABLE IF NOT EXISTS "+cTable+" ("

   for i := 1 to len(aStruct)
      mFldNm := aStruct[i, DBS_NAME]
      mFldType := aStruct[i, DBS_TYPE]
      mFldLen := aStruct[i, DBS_LEN]
      mFldDec := aStruct[i, DBS_DEC]

      if i > 1
         mSql += ", "
      endif
      mSql += alltrim(mFldnm)+" "

      do case
      case mFldType = "C"
         mSql += "CHAR("+LTRIM(STR(mFldLen))+")"
      case mFldType = "D"
         mSql += "DATE"
      case mFldType = "T"
         mSql += "DATETIME"
      case mFldType = "N"
         mSql += "DECIMAL("+LTRIM(STR(mFldLen))+", "+LTRIM(STR(mFldDec))+")"
      case mFldType = "F"
         mSql += "FLOAT"
      case mFldType = "I"
         mSql += "INTEGER"
      case mFldType = "B"
         mSql += "DOUBLE"
      case mFldType = "Y"
         mSql += "DECIMAL(20, 4)"
      case mFldType = "L"
         mSql += "SMALLINT(1)"
      case mFldType = "M"
         mSql += "TEXT"
      case mFldType = "G"
         mSql += "BLOB"
      otherwise
         msginfo("Invalid Field Type: "+mFldType)
         return nil
      endcase
   next

   mSql += ")"

   //msginfo(mSql)

   if !miscsql(dbo, mSql)
      return nil
   endif

   sql.progress.value := 0
   sql.progress.visible := .t.
   sql.status.value := ""
   totrec := reccount()
   nrec := 1
   go top
   do while !eof()
      sql.progress.value := nrec/totrec *100
      sql.status.value := alltrim(str(nrec))+" of "+alltrim(str(totrec))+" Records processed."

      mSql := "INSERT INTO "+cTable+" VALUES "
      if totrec - nrec > 20
         nvalues := 20
      else
         nvalues := 1
      endif
      
      nrec := nrec + nvalues
      
      for count1 := 1 to nvalues
         msql := msql + "("

         for i := 1 to len(aStruct)
            mFldNm := aStruct[i, DBS_NAME]
      
            if i > 1
               mSql += ", "
            endif
      
            mSql += c2sql(&mFldNm)
         next

         mSql += ")"
         if count1 <> nvalues
            msql := msql + ","
         endif   
         skip
         
      next count1
      
      if !miscsql(dbo, mSql)
      	msgbox("Problem in Query: "+mSql)
         return nil
      endif

   enddo
   
   sql.status.value := ""
   sql.progress.value := 0
   sql.progress.visible := .f.
   msginfo("Successfully exported")   
return nil














Function DbExist(dbo, cDatabase)
   local aDbList := {}
   cDatabase := lower(cDatabase)
   aDbList := dbo:ListDbs()
   if dbo:neterr()
      msginfo("Error in verifying database list: "+dbo:error())
      return .f.
   endif
return (ascan(aDbList, {|x| lower(x) == lower(cDatabase)}) > 0)



Function TableExist(dbo, cTable)
   local aTableList := {}
   cTable = lower(cTable)
   aTableList := dbo:ListTables()
   if dbo:neterr()
      msginfo("Error in verifying table list: "+dbo:error())
      return .f.
   endif
return (ascan(aTableList, {|x| lower(x) == lower(cTable)}) > 0)

function browsefordbfs
   local aStruct := {}, cSql, i, mFldNm, mFldtype, mFldLen, mFldDec, mSql,nvalues,count1, tablecount1
   local aFileNames := {}
   local cFileName := ''
   local cTableName := ''
   if dbo == nil
      msgstop("No Connection to server!")
      return nil
   endif
   aFileNames := GetFile({{"DBF Files","*.dbf"}},"Select Multiple dbf files to export",,.t.,.f.)
   if len( aFileNames ) > 0   
      for tablecount1 := 1 to len( aFileNames )
         cFileName := aFileNames[ tablecount1 ]
         use &cFileName
         cTableName := DBFFileName( cFileName )
         wait window 'Exporting to new table - ' + cTableName + ' (' + alltrim( str( tablecount1 ) ) + '/' + alltrim( str( len( aFileNames ) ) ) + ') Tables ' nowait
         cTable := alltrim( cTableName ) 
         for i := 1 to sql.tables.itemcount
            if upper(alltrim(sql.tables.item(i))) == upper(alltrim(cTable))
               if msgyesno( "Destination table already exists. Do you want to drop the table? If you select <No> the export process will be cancelled.","DBF2MySQL")
                  msql := "drop table "+cTable           
                  if !miscsql(dbo, mSql)
                     return nil
                  endif
               else
                  wait clear
                  return nil
               endif               
            endif   
         next i

         aStruct = DbStruct()

         mSql := "CREATE TABLE IF NOT EXISTS "+cTable+" ("

         for i := 1 to len(aStruct)
            mFldNm := aStruct[i, DBS_NAME]
            mFldType := aStruct[i, DBS_TYPE]
            mFldLen := aStruct[i, DBS_LEN]
            mFldDec := aStruct[i, DBS_DEC]

            if i > 1
               mSql += ", "
            endif
            mSql += alltrim(mFldnm)+" "

            do case
            case mFldType = "C"
               mSql += "CHAR("+LTRIM(STR(mFldLen))+")"
            case mFldType = "D"
               mSql += "DATE"
            case mFldType = "T"
               mSql += "DATETIME"
            case mFldType = "N"
               mSql += "DECIMAL("+LTRIM(STR(mFldLen))+", "+LTRIM(STR(mFldDec))+")"
            case mFldType = "F"
               mSql += "FLOAT"
            case mFldType = "I"
               mSql += "INTEGER"
            case mFldType = "B"
               mSql += "DOUBLE"
            case mFldType = "Y"
               mSql += "DECIMAL(20, 4)"
            case mFldType = "L"
               mSql += "SMALLINT(1)"
            case mFldType = "M"
               mSql += "TEXT"
            case mFldType = "G"
               mSql += "BLOB"
            otherwise
               msginfo("Invalid Field Type: "+mFldType)
               return nil
            endcase
         next

         mSql += ")"

         //msginfo(mSql)

         if !miscsql(dbo, mSql)
            return nil
         endif

         sql.progress.value := 0
         sql.progress.visible := .t.
         sql.status.value := ""
         totrec := reccount()
         nrec := 1
         go top
         do while !eof()
            sql.progress.value := nrec/totrec *100
            sql.status.value := alltrim(str(nrec))+" of "+alltrim(str(totrec))+" Records processed."

            mSql := "INSERT INTO "+cTable+" VALUES "
            if totrec - nrec > 20
               nvalues := 20
            else
               nvalues := 1
            endif
            
            nrec := nrec + nvalues
            
            for count1 := 1 to nvalues
               msql := msql + "("

               for i := 1 to len(aStruct)
                  mFldNm := aStruct[i, DBS_NAME]
            
                  if i > 1
                     mSql += ", "
                  endif
            
                  mSql += c2sql(&mFldNm)
               next

               mSql += ")"
               if count1 <> nvalues
                  msql := msql + ","
               endif   
               skip
               
            next count1
            
            if !miscsql(dbo, mSql)
               msgbox("Problem in Query: "+mSql)
               return nil
            endif

         enddo
         msql := ''
         close all
      next tablecount1   
      wait clear
      msginfo("Successfully exported all tables")   
   endif   
   sql.status.value := ""
   sql.progress.value := 0
   sql.progress.visible := .f.
return nil


FUNCTION DBFFileName( cFile )
LOCAL nPos, cFileName
IF (nPos := RAT("\", cFile)) != 0
   cFileName = SUBSTR( cFile, nPos + 1 )
   if len( cFileName ) > 4
      if upper( substr( cFileName, len( cFileName ) - 3 ) ) == '.DBF'
        cFileName := substr( cFileName, 1, len( cFileName ) - 4 )
      endif
   endif     
ELSE
   cFileName = ""
ENDIF
RETURN cFileName