#Include "MiniGui.ch"
#include "DbStruct.ch"

declare window frmmain

Function NewTable()
   local aStruct := {}, cSql, i, mFldNm, mFldtype, mFldLen, mFldDec, mSql
   
      
   
   do while .not. lopened
      if msgyesno("You had not selected a DBF table. Do you want to do now?")
         browsefordbf()
      else
         return nil
      endif
   enddo

   cTable := alltrim(sql.newtable.value)

   aStruct = DbStruct()

   mSql := "CREATE TABLE IF NOT EXISTS "+cTable+" ("

   for i := 1 to len(aStruct)
      mFldNm := aStruct[i, DBS_NAME]
      mFldType := aStruct[i, DBS_TYPE]
      mFldLen := aStruct[i, DBS_LEN]
      mFldDec := aStruct[i, DBS_DEC]

      if i > 1
         mSql += ", "
      endif
      mSql += alltrim(mFldnm)+" "

      do case
      case mFldType = "C"
         mSql += "CHAR("+LTRIM(STR(mFldLen))+")"
      case mFldType = "D"
         mSql += "DATE"
      case mFldType = "T"
         mSql += "DATETIME"
      case mFldType = "N"
         mSql += "DECIMAL("+LTRIM(STR(mFldLen))+", "+LTRIM(STR(mFldDec))+")"
      case mFldType = "F"
         mSql += "FLOAT"
      case mFldType = "I"
         mSql += "INTEGER"
      case mFldType = "B"
         mSql += "DOUBLE"
      case mFldType = "Y"
         mSql += "DECIMAL(20, 4)"
      case mFldType = "L"
         mSql += "SMALLINT(1)"
      case mFldType = "M"
         mSql += "TEXT"
      case mFldType = "G"
         mSql += "BLOB"
      otherwise
         msginfo("Invalid Field Type: "+mFldType)
         return nil
      endcase
   next

   mSql += ")"

   //msginfo(mSql)

   if !miscsql(dbo, mSql)
      return nil
   endif

   sql.progress.value := 0
   sql.progress.visible := .t.

   go top
   do while !eof()
      sql.progress.value := recno()/reccount()*100

      mSql := "INSERT INTO "+cTable+" VALUES ("

      for i := 1 to len(aStruct)
         mFldNm := aStruct[i, DBS_NAME]

         if i > 1
            mSql += ", "
         endif

         mSql += c2sql(&mFldNm)
      next

      mSql += ")"

      if !miscsql(dbo, mSql)
      	msgbox("Problem in Query: "+mSql)
         return nil
      endif

      select &cTable
      skip
   enddo
   sql.progress.value := 0
   sql.progress.visible := .f.
return nil














Function DbExist(dbo, cDatabase)
   local aDbList := {}
   cDatabase := lower(cDatabase)
   aDbList := dbo:ListDbs()
   if dbo:neterr()
      msginfo("Error in varifying database list: "+dbo:error())
      return .f.
   endif
return (ascan(aDbList, {|x| lower(x) == lower(cDatabase)}) > 0)



Function TableExist(dbo, cTable)
   local aTableList := {}
   cTable = lower(cTable)
   aTableList := dbo:ListTables()
   if dbo:neterr()
      msginfo("Error in varifying table list: "+dbo:error())
      return .f.
   endif
return (ascan(aTableList, {|x| lower(x) == lower(cTable)}) > 0)

