# include "minigui.ch"

FUNCTION connect2db(host,user,password,dbname)
default dbname := ""
dbo := tmysqlserver():new(AllTrim(host),AllTrim(user),AllTrim(password))
IF dbo:NetErr()
   msginfo(dbo:ERROR())
   RETURN .f.
ENDIF
if len(alltrim(dbname)) > 0
   dbo:selectdb(dbname)
   IF dbo:NetErr()
      msginfo(dbo:ERROR())
      RETURN .f.
   ENDIF
endif    
//msginfo("Successfully Connected to the MySQL Server")
RETURN .t.
	
function sql(dbo1,qstr)
local table := nil
local currow := nil
local tablearr := {}
local rowarr := {}
local curdateformat := set(_SET_DATEFORMAT)
local i := 0
local j := 0
if dbo1 == nil
   return nil
endif
set date ansi
table := dbo1:query(qstr)
set(_SET_DATEFORMAT,curdateformat)
if table:neterr()
   msgstop(table:error())
   table:destroy()
   return tablearr
else
   if table:lastrec() > 0
      asize(tablearr,0)
      for i := 1 to table:lastrec()
         asize(rowarr,0)     
         currow := table:getrow(i)
         for j := 1 to table:fcount()         
            aadd(rowarr,currow:fieldget(j))
         next j
         aadd(tablearr,aclone(rowarr))
      next i
   endif
   table:destroy()
   return tablearr
endif
return tablearr

function miscsql(dbo,qstr)
local curdateformat := set( _SET_DATEFORMAT)
if dbo == nil
   return nil
endif
set date ansi
table := dbo:query(qstr)
set( _SET_DATEFORMAT,curdateformat)
if table:NetErr()
    msgstop(table:ERROR())
    table:destroy()
    return  .f.
endif
table:destroy()
return .t.

function C2SQL(Value)

   local cValue := ""
   do case
   case Valtype(Value) == "N"
      cValue := AllTrim(Str(Value))

   case Valtype(Value) == "D"
   	if !empty(Value)
   		cValue := "'"+DTOS(value)+"'"
   	else
   		cValue := "'00000000'"
   	endif
   case Valtype(Value) $ "CM"
      IF Empty( Value)
         cValue="''"
      ELSE
         cValue := "'"
         Value:= mysql_escape_string( value )
         cValue+= value+ "'"
      ENDIF

   case Valtype(Value) == "L"
      cValue := AllTrim(Str(iif(Value == .F., 0, 1)))

   otherwise
      cValue := "''"                                // NOTE: Here we lose values we cannot convert

   endcase

   return cValue


